// com.cpp, Benutzung der seriellen Schnitsttelle unter
// Borland-C++-Builder V 4.0
// sa/hhs, 19.12.2000
//
// Anleitung und nderungsgeschichte siehe zugehrige Headerdatei "com.h"
//
//
// Der hier verwendete Typ DWORD (aus WIN-API) entspricht dem C++ Standard-Typ
// "unsigned long", also einer 32-Bit-Zahl ohne Vorzeichen.
//
// Der Typ BOOL (aus Win-API) entspricht dem Typ bool aus
// neuerem C++ Standard.
//
// Die Typen DWORD und BOOL knnten durch
// unsigned long bzw. bool ersetzt werden, mglicherweise gibt's dann aber
// Probleme mit lteren Versionen des C++ Builders.

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "COM.h"
#include <winbase.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)

// "handle" fr ser. Schnittstelle, wird auf ungltigen Wert initialisiert
static HANDLE serialhandle=INVALID_HANDLE_VALUE;


BOOL OeffneSeriell(int comnummer,int baudrate,byte bitsprozeichen, byte paritaet, int stopbits)
{DCB mydcb; // device control block, siehe "winbase.h"
BOOL ok;
char comname [5] ="COMx";

if (serialhandle != INVALID_HANDLE_VALUE) return FALSE;

comname[3]= char(int ('0')+comnummer);
serialhandle = CreateFile(comname,
         GENERIC_READ | GENERIC_WRITE,
         0,              // shared mode
         NULL,           // kein Zeiger auf Sicherheitsattribute
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         0);
GetLastError();
// wenn Schnittstelle nicht vorhanden oder schon belegt, beende Funktion mit
// Ergebnis FALSE
if (serialhandle == INVALID_HANDLE_VALUE)
  return FALSE;

// Lese Gertesteuerblock der aktuellen Schnittstelle in eigene
// Datenstruktur "mydcb" ein.
ok= GetCommState(serialhandle,&mydcb);
if (!ok) return FALSE;

// ***************************** setze bergebene Parameter
mydcb.BaudRate=baudrate;    // bergebene Baudrate
mydcb.Parity=paritaet;      // bergebene Paritt
// gebe Empfangsseitige Parittsprfung nur bei gerader und ungerader
// Paritt frei
if (paritaet ==1  || paritaet ==2)
  mydcb.fParity=1;
else
  mydcb.fParity=0;

mydcb.ByteSize=bitsprozeichen;
mydcb.StopBits=0;


// setze andere mgliche Einstellungen auf Standardwerte.
// Bei Bedarf hier ndern. Siehe auch Struktur "_DCB"  in winbase.h

mydcb.fBinary=1;         // Binrmodus, kein EOF-Check
mydcb.fOutxCtsFlow=0;    // Bei Sendung kein aktives CTS an Schnittstelle ntig
mydcb.fOutxDsrFlow=0;    // Bei Sendung Kein aktives DSR an Schnittstelle ntig

mydcb.fDtrControl=DTR_CONTROL_ENABLE; //DTR dauernd aktiv
           //Alternativen:DTR_CONTROL_DISABLE: DTR immer inaktiv
           //             DTR_CONTROL_HANDSHAKE: DTR ist Empfangshandshake

mydcb.fDsrSensitivity=0;  // ?? Angeblich wrde "1" bewirken,
   // dass Empfangszeichen ignoriert werden, wenn DSR = high. Vermutlich Fehler
   // in Dokumentation. Sinnvoll wre, Zeichen zu ignorieren, wenn DSR = low.

mydcb.fTXContinueOnXoff=0;// bertragung nicht fortsetzen, wenn xoff empfangen
mydcb.fOutX=0;            // Kein Xon-Xoff-Protokoll bei eigener Sendung
mydcb.fInX=0;             // Kein Xon-Xoff-Protokoll bei eigenem Empfang
mydcb.fErrorChar=0;       // bei Parittsfehler Zeichen nicht durch
                          // "Ersatzzeichen" ersetzen.
mydcb.fNull=0;            // NULL-Zeichen nicht entfernen
mydcb.fRtsControl=RTS_CONTROL_ENABLE; //RTS aktiv
    //Alternativen: RTS_CONTROL_DISABLE: RTS inaktiv
    //              RTS_CONTROL_HANDSHAKE: RTS fr RTS-CTS-Handshake
    //              RTS_CONTROL_TOGGLE: RTS aktiv nur whrend eigener Sendung
mydcb.fAbortOnError=0;    // kein Abbruch bei Fehler
mydcb.XonLim=2048;        // Transmit X-ON threshold
mydcb.XoffLim=512;        // Transmit X-OFF threshold

mydcb.XonChar=0x11;       //Standard-Xon-Zeichen
mydcb.XoffChar=0x13;      //Standard-Xoff-Zeichen
mydcb.ErrorChar=0;        //Kein Ersatzzeichen definiert fr Parittsfehler
mydcb.EofChar=0;          //kein EOF-Zeichen definiert, nach dem gesucht wird
mydcb.EvtChar=0;          //kein Ereigniszeichen definiert


ok = SetCommState(serialhandle,&mydcb);
// spielt genderte Struktur zurck an System

return ok;
};


void SchliesseSeriell(void)
{
CloseHandle(serialhandle);
serialhandle=INVALID_HANDLE_VALUE;
}

DWORD SendeZeichen(char &puffer, DWORD anzahl)
{BOOL ok; DWORD gesendet;
ok=WriteFile (serialhandle,&puffer,anzahl,&gesendet,0);
if (ok) return gesendet; else return 0;
}

DWORD SendeString(AnsiString &s)
{BOOL ok; DWORD gesendet;
ok=WriteFile (serialhandle,&s[1],s.Length(),&gesendet,0);
if (ok) return gesendet; else return 0;
}


DWORD ZeichenImEmpfangspuffer(void)
{BOOL yes; DWORD errors;  COMSTAT mycomstat;
yes=ClearCommError (serialhandle, &errors, &mycomstat);
if (yes)
  return mycomstat.cbInQue;
else
  return 0;
}


DWORD HoleZeichen(char &puffer, DWORD anzahl)
{BOOL ok; DWORD gelesen;
ok=ReadFile(serialhandle,&puffer,anzahl,&gelesen,0);
if (ok) return gelesen; else return 0;
}

DWORD HoleString(AnsiString &s)
{BOOL ok=false; DWORD gelesen, z = ZeichenImEmpfangspuffer();
 s = "";
 // 2.4.00 sa: Schleifenzhler int i in DWORD i gendert, um keine
 //Warnung zu erhalten.
 for (DWORD i=0; i<z; i++) s = s + " ";
 if (z > 0) ok=ReadFile(serialhandle,&s[1],z,&gelesen,0);
if (ok) return gelesen; else return 0;
}


BOOL PufferLeeren(void)
{return (PurgeComm (serialhandle,PURGE_TXABORT | PURGE_RXABORT
                      | PURGE_TXCLEAR | PURGE_RXCLEAR) );
}


BOOL CTSActive(void)
{
DWORD status; // 32-Bit-Wort fr Ergebnis
if (!GetCommModemStatus(serialhandle,&status)) return false;
return status & MS_CTS_ON;  // Bitweise UND-Verknpfung des
                            // "status" mit Maske fr Bit CTS
}

BOOL DSRActive(void)
{
DWORD status;
if (!GetCommModemStatus(serialhandle,&status)) return false;
return status & MS_DSR_ON;
}

BOOL RIActive(void)
{
DWORD status;
if (!GetCommModemStatus(serialhandle,&status)) return false;
return status & MS_RING_ON;
}

BOOL DCDActive(void)
{
DWORD status;
if (!GetCommModemStatus(serialhandle,&status)) return false;
return status & MS_RLSD_ON;
}

void SetDtr (void)
// setzt DTR = High (+12V)
{EscapeCommFunction(serialhandle,SETDTR);}

void ClrDtr(void)
// Setzt DTR = Low (-12V)
{EscapeCommFunction(serialhandle,CLRDTR);}

void SetRts (void)
// Setzt RTS = High (+12V)
{EscapeCommFunction(serialhandle,SETRTS);}

void ClrRts (void)
// Setzt RTS = Low (-12V)
{EscapeCommFunction(serialhandle,CLRRTS);}

